import { Logger, ILocalPackageManager, StorageUpdateCallback, PackageTransformer, StorageWriteCallback, CallbackAction, Package, ReadPackageCallback } from '@verdaccio/types';
import { UploadTarball, ReadTarball } from '@verdaccio/streams';
import { StorageProxyConfig } from '../types/index';
export default class StoragePluginManager implements ILocalPackageManager {
    logger: Logger;
    packageName: string;
    config: StorageProxyConfig;
    packumentPackageStorage: ILocalPackageManager;
    tarballPackageStorage: ILocalPackageManager;
    constructor(config: StorageProxyConfig, packageName: string, logger: Logger, loadedBackends: any);
    updatePackage(name: string, updateHandler: StorageUpdateCallback, onWrite: StorageWriteCallback, transformPackage: PackageTransformer, onEnd: CallbackAction): void;
    deletePackage(fileName: string, callback: CallbackAction): void;
    removePackage(callback: CallbackAction): void;
    createPackage(name: string, data: Package, callback: CallbackAction): void;
    savePackage(pkgName: string, pkg: Package, callback: CallbackAction): void;
    readPackage(pkgName: string, callback: ReadPackageCallback): void;
    writeTarball(name: string): UploadTarball;
    readTarball(name: string): ReadTarball;
}
