import { Config, Logger, IPlugin } from '@verdaccio/types';
/**
 * Load a plugin following the rules
 * - First try to load from the internal directory plugins (which will disappear soon or later).
 * - A second attempt from the external plugin directory
 * - A third attempt from node_modules, in case to have multiple match as for instance verdaccio-ldap
 * and sinopia-ldap. All verdaccio prefix will have preferences.
 * @param {*} config a reference of the configuration settings
 * @param {*} pluginId a plugin Id
 * @param {*} pluginConfig a plugin config
 * @param {*} params a set of params to initialize the plugin
 * @param {*} sanityCheck callback that check the shape that should fulfill the plugin
 * @return {*} loaded plugin
 */
export default function loadPlugin<T extends IPlugin<T>>(config: Config, logger: Logger, pluginId: string, pluginConfig: any, params: any, sanityCheck: any, prefix?: string): any;
