import { Logger, Callback, IPluginStorage, PluginOptions, IPackageStorage, TokenFilter, Token, Config, onEndSearchPackage, onSearchPackage, onValidatePackage } from '@verdaccio/types';
import { StorageProxyConfig } from '../types/index';
export default class VerdaccioStoragePlugin implements IPluginStorage<StorageProxyConfig> {
    config: StorageProxyConfig & Config;
    version?: string;
    logger: Logger;
    loadedBackends: any;
    constructor(config: StorageProxyConfig, options: PluginOptions<StorageProxyConfig>);
    getSecret(): Promise<string>;
    setSecret(secret: string): Promise<any>;
    add(name: string, callback: Callback): void;
    search(onPackage: onSearchPackage, onEnd: onEndSearchPackage, validateName: onValidatePackage): void;
    remove(name: string, callback: Callback): void;
    get(callback: Callback): void;
    /**
     * Create an instance of the `PackageStorage`
     * @param packageInfo
     */
    getPackageStorage(packageInfo: string): IPackageStorage;
    saveToken(token: Token): Promise<any>;
    deleteToken(user: string, tokenKey: string): Promise<any>;
    readTokens(filter: TokenFilter): Promise<Token[]>;
}
